<?php
/*
*	Copyright VeryIDE,2007-2010
*	http://www.veryide.com/
*
*	浏览器、客户端函数包
*
*	$Id: client.php,v3 19:47 2007-07-27 Leilei $
*/

/*
	下载报表数据
	$name		名称
	$content	内容
*/
function report( $name, $content ){	
	global $Project;
	
	//输出CSV
	header("Cache-Control: public");
	header("Content-type:application/msexcel; charset=GBK");
	
	//IE就对文件名进行编码
	if( eregi("MSIE" , $_SERVER["HTTP_USER_AGENT"]) ){
		
		$reg = "/^.+MSIE (\d+\.\d+).+$/";
		
		$ver = preg_replace ($reg, "$1",$_SERVER["HTTP_USER_AGENT"]);
		
		//$name = str_replace(array(chr(63),"?","/","\\","<",">","'",'"',"|"),"_",$VICACHE["mod.forms"]["name"]);
		
		$name = preg_replace('/[^\x7f-\xff\d]/',"",$name);
		
		//$name=urlencode($VICACHE["mod.forms"]["name"]);//将关键字编码
		//$name=preg_replace("/(%7E|%60|%21|%40|%23|%24|%25|%5E|%26|%27|%2A|%28|%29|%2B|%7C|%5C|%3D|\-|_|%5B|%5D|%7D|%7B|%3B|%22|%3A|%3F|%3E|%3C|%2C|\.|%2F|%A3%BF|%A1%B7|%A1%B6|%A1%A2|%A1%A3|%A3%AC|%7D|%A1%B0|%A3%BA|%A3%BB|%A1%AE|%A1%AF|%A1%B1|%A3%FC|%A3%BD|%A1%AA|%A3%A9|%A3%A8|%A1%AD|%A3%A4|%A1%A4|%A3%A1)+/",'',$name);
		
		
		if( $ver == "6.0" || $ver == "6" ){		
			header("Content-Disposition:attachment; filename=\"".urlencode($name).".csv\"");		
		}else{
			header("Content-Disposition:attachment; filename=\"".$name.".csv\"");
		}
		
	}else{
		header("Content-Disposition:attachment; filename=\"".(addslashes($name)).".csv\"");
	}
	
	header("Accept-Ranges: bytes");
	
	echo(chr(255).chr(254));
	
	//$report = iconv($Project["charset"],"UTF-8",$report);
	
	//echo $report;
	
	echo(iconv($Project["charset"],"UTF-16LE".'//IGNORE',$content));
	
}

//获取访问者浏览器
function browse(){
	$Agent = $_SERVER["HTTP_USER_AGENT"];
	
	$appname="";
	$appver="";
	
	if( eregi("MSIE" , $Agent) ){
	
		$appname = "IE";
		$reg = "/^.+MSIE (\d+\.\d+).+$/";
	
	}else{
	
		if (eregi("Chrome" , $Agent)){
			$appname = "Chrome";
			
			$reg = "/^.+Chrome\/(.*) Safari(.*)/";
			
		}else if (eregi("Safari" , $Agent)){
		
			//iPhone
			if (stripos("Mobile" , $Agent)){
				$appname = "Safari";
				$reg = "/^.+Version\/([\d\.]+?) Mobile.+$/";
				
			//Nokia
			}else if(stripos("Series60" , $Agent)){
				$appname = "Safari";
				$reg = "/^.+Safari\/([\d\.].*)+$/";
				
			//PC
			}else{
				$appname = "Safari";
				$reg = "/^.+Version\/([\d\.]+?) Safari.+$/";
			}
		}else if (eregi ("Opera" , $Agent)){
			$appname = "Opera";
			$reg = "/^.{0,}Opera\/(.+?) \(.+$/";
			
		}else if (eregi ("Firefox" , $Agent)){
			$appname = "Firefox";
			$reg = "/^.+Firefox\/([\d\.]+).{0,}$/";
			
		}else{
			$appname = "Unknown";
			$reg = "";
		}
		
	}
	
	if($reg){
		$appnver = preg_replace ($reg, "$1",$Agent);
	}else{
		$appnver = 0;
	}
	
	$browser=array($appname,$appnver);
	return $browser;
}

//获取访问者操作系统
function platform() {
	$Agent = $_SERVER["HTTP_USER_AGENT"];
	$os="";
	
	if (eregi('win',$Agent) && strpos($Agent, '95')) {
	$os="Windows 95";
	}
	elseif (eregi('win 9x',$Agent) && strpos($Agent, '4.90')) {
	$os="Windows ME";
	}
	elseif (eregi('win',$Agent) && ereg('98',$Agent)) {
	$os="Windows 98";
	}
	elseif (eregi('win',$Agent) && eregi('nt 5.0',$Agent)) {
	$os="Windows 2000";
	}
	elseif (eregi('win',$Agent) && eregi('nt 5.1',$Agent)) {
	$os="Windows XP";
	}
	elseif (eregi('win',$Agent) && eregi('nt 5.2',$Agent)) {
	$os="Windows Server 2003";
	}
	elseif (eregi('win',$Agent) && eregi('nt 6.0',$Agent)) {
	$os="Windows Vista";
	}
	elseif (eregi('win',$Agent) && eregi('nt',$Agent)) {
	$os="Windows NT";
	}
	elseif (eregi('win',$Agent) && ereg('32',$Agent)) {
	$os="Windows 32";
	}
	elseif (eregi('linux',$Agent)) {
	$os="Linux";
	}
	elseif (eregi('unix',$Agent)) {
	$os="Unix";
	}
	elseif (eregi('sun',$Agent) && eregi('os',$Agent)) {
	$os="SunOS";
	}
	elseif (eregi('ibm',$Agent) && eregi('os',$Agent)) {
	$os="IBM OS/2";
	}
	elseif (eregi('Mac',$Agent) && eregi('PC',$Agent)) {
	$os="Macintosh";
	}
	elseif (eregi('Mac',$Agent) && eregi('Intel',$Agent)) {
	$os="MacIntel";
	}
	elseif (eregi('PowerPC',$Agent)) {
	$os="PowerPC";
	}
	elseif (eregi('AIX',$Agent)) {
	$os="AIX";
	}
	elseif (eregi('HPUX',$Agent)) {
	$os="HPUX";
	}
	elseif (eregi('NetBSD',$Agent)) {
	$os="NetBSD";
	}
	elseif (eregi('BSD',$Agent)) {
	$os="BSD";
	}
	elseif (ereg('OSF1',$Agent)) {
	$os="OSF1";
	}
	elseif (ereg('IRIX',$Agent)) {
	$os="IRIX";
	}
	elseif (eregi('FreeBSD',$Agent)) {
	$os="FreeBSD";
	}
	if ($os=='') $os = "Unknown";
	return $os;
}

//返回IP所在地
function convertip($ip) {
	$return = '';

	if(preg_match("/^\d{1,3}\.\d{1,3}\.\d{1,3}\.\d{1,3}$/", $ip)) {
		$iparray = explode('.', $ip);

		if($iparray[0] == 10 || $iparray[0] == 127 || ($iparray[0] == 192 && $iparray[1] == 168) || ($iparray[0] == 172 && ($iparray[1] >= 16 && $iparray[1] <= 31))) {
			$return = '- LAN';
		} elseif($iparray[0] > 255 || $iparray[1] > 255 || $iparray[2] > 255 || $iparray[3] > 255) {
			$return = '- Invalid IP Address';
		} else {
			
			$tinyipfile = dirname(__FILE__).'/../source/ipdata/ipdata.dat';
			$fullipfile = dirname(__FILE__).'/../source/ipdata/wry.dat';
			
			if(@file_exists($fullipfile)) {
				$return = convertip_full($ip, $fullipfile);
			} elseif(@file_exists($tinyipfile)) {
				$return = convertip_tiny($ip, $tinyipfile);
			}
		}
	}

	return $return;

}

function convertip_tiny($ip, $ipdatafile) {

	static $fp = NULL, $offset = array(), $index = NULL;

	$ipdot = explode('.', $ip);
	$ip    = pack('N', ip2long($ip));

	$ipdot[0] = (int)$ipdot[0];
	$ipdot[1] = (int)$ipdot[1];

	if($fp === NULL && $fp = @fopen($ipdatafile, 'rb')) {
		$offset = unpack('Nlen', fread($fp, 4));
		$index  = fread($fp, $offset['len'] - 4);
	} elseif($fp == FALSE) {
		return  '- Invalid IP data file';
	}

	$length = $offset['len'] - 1028;
	$start  = unpack('Vlen', $index[$ipdot[0] * 4] . $index[$ipdot[0] * 4 + 1] . $index[$ipdot[0] * 4 + 2] . $index[$ipdot[0] * 4 + 3]);

	for ($start = $start['len'] * 8 + 1024; $start < $length; $start += 8) {

		if ($index{$start} . $index{$start + 1} . $index{$start + 2} . $index{$start + 3} >= $ip) {
			$index_offset = unpack('Vlen', $index{$start + 4} . $index{$start + 5} . $index{$start + 6} . "\x0");
			$index_length = unpack('Clen', $index{$start + 7});
			break;
		}
	}

	fseek($fp, $offset['len'] + $index_offset['len'] - 1024);
	if($index_length['len']) {
		return '- '.fread($fp, $index_length['len']);
	} else {
		return '- Unknown';
	}

}

function convertip_full($ip, $ipdatafile) {

	if(!$fd = @fopen($ipdatafile, 'rb')) {
	//if(!$fd = @fopen($ipdatafile)) {
		return '- Invalid IP data file (full)';
	}

	$ip = explode('.', $ip);
	$ipNum = $ip[0] * 16777216 + $ip[1] * 65536 + $ip[2] * 256 + $ip[3];

	if(!($DataBegin = fread($fd, 4)) || !($DataEnd = fread($fd, 4)) ) return;
	@$ipbegin = implode('', unpack('L', $DataBegin));
	if($ipbegin < 0) $ipbegin += pow(2, 32);
	@$ipend = implode('', unpack('L', $DataEnd));
	if($ipend < 0) $ipend += pow(2, 32);
	$ipAllNum = ($ipend - $ipbegin) / 7 + 1;

	$BeginNum = $ip2num = $ip1num = 0;
	$ipAddr1 = $ipAddr2 = '';
	$EndNum = $ipAllNum;

	while($ip1num > $ipNum || $ip2num < $ipNum) {
		$Middle= intval(($EndNum + $BeginNum) / 2);

		fseek($fd, $ipbegin + 7 * $Middle);
		$ipData1 = fread($fd, 4);
		if(strlen($ipData1) < 4) {
			fclose($fd);
			return '- System Error';
		}
		$ip1num = implode('', unpack('L', $ipData1));
		if($ip1num < 0) $ip1num += pow(2, 32);

		if($ip1num > $ipNum) {
			$EndNum = $Middle;
			continue;
		}

		$DataSeek = fread($fd, 3);
		if(strlen($DataSeek) < 3) {
			fclose($fd);
			return '- System Error';
		}
		$DataSeek = implode('', unpack('L', $DataSeek.chr(0)));
		fseek($fd, $DataSeek);
		$ipData2 = fread($fd, 4);
		if(strlen($ipData2) < 4) {
			fclose($fd);
			return '- System Error';
		}
		$ip2num = implode('', unpack('L', $ipData2));
		if($ip2num < 0) $ip2num += pow(2, 32);

		if($ip2num < $ipNum) {
			if($Middle == $BeginNum) {
				fclose($fd);
				return '- Unknown';
			}
			$BeginNum = $Middle;
		}
	}

	$ipFlag = fread($fd, 1);
	if($ipFlag == chr(1)) {
		$ipSeek = fread($fd, 3);
		if(strlen($ipSeek) < 3) {
			fclose($fd);
			return '- System Error';
		}
		$ipSeek = implode('', unpack('L', $ipSeek.chr(0)));
		fseek($fd, $ipSeek);
		$ipFlag = fread($fd, 1);
	}

	if($ipFlag == chr(2)) {
		$AddrSeek = fread($fd, 3);
		if(strlen($AddrSeek) < 3) {
			fclose($fd);
			return '- System Error';
		}
		$ipFlag = fread($fd, 1);
		if($ipFlag == chr(2)) {
			$AddrSeek2 = fread($fd, 3);
			if(strlen($AddrSeek2) < 3) {
				fclose($fd);
				return '- System Error';
			}
			$AddrSeek2 = implode('', unpack('L', $AddrSeek2.chr(0)));
			fseek($fd, $AddrSeek2);
		} else {
			fseek($fd, -1, SEEK_CUR);
		}

		while(($char = fread($fd, 1)) != chr(0))
		$ipAddr2 .= $char;

		$AddrSeek = implode('', unpack('L', $AddrSeek.chr(0)));
		fseek($fd, $AddrSeek);

		while(($char = fread($fd, 1)) != chr(0))
		$ipAddr1 .= $char;
	} else {
		fseek($fd, -1, SEEK_CUR);
		while(($char = fread($fd, 1)) != chr(0))
		$ipAddr1 .= $char;

		$ipFlag = fread($fd, 1);
		if($ipFlag == chr(2)) {
			$AddrSeek2 = fread($fd, 3);
			if(strlen($AddrSeek2) < 3) {
				fclose($fd);
				return '- System Error';
			}
			$AddrSeek2 = implode('', unpack('L', $AddrSeek2.chr(0)));
			fseek($fd, $AddrSeek2);
		} else {
			fseek($fd, -1, SEEK_CUR);
		}
		while(($char = fread($fd, 1)) != chr(0))
		$ipAddr2 .= $char;
	}
	fclose($fd);

	if(preg_match('/http/i', $ipAddr2)) {
		$ipAddr2 = '';
	}
	$ipaddr = "$ipAddr1 $ipAddr2";
	$ipaddr = preg_replace('/CZ88\.NET/is', '', $ipaddr);
	$ipaddr = preg_replace('/^\s*/is', '', $ipaddr);
	$ipaddr = preg_replace('/\s*$/is', '', $ipaddr);
	if(preg_match('/http/i', $ipaddr) || $ipaddr == '') {
		$ipaddr = '- Unknown';
	}	

	return '- '.$ipaddr;

}


?>